<?php include('./templates/cabecera.php'); ?>
<?php include('./config/db.php'); ?>
<?php include('funciones.php'); ?>
<?php 
$html = "actividades.php";
if(!$_GET){
    echo "<script>location.href='$html?pagina=1';</script>";
}

if($_SESSION['perfil'] == 2){
    echo "<script>location.href='index.php?pagina=1';</script>";
}

$error = "";
$ok = "";
$txtFiltro=(isset($_GET['txtFiltro']))?$_GET['txtFiltro']:"";
$totalPaginas = 10;
$paginadorSalto = 9;
$txtId=(isset($_POST['txtId']))?$_POST['txtId']:"";
if(isset($_POST['chkActivo']) == "on"){
    $chkActivo = 1; //activo
}else{
    $chkActivo = 0; //inactivo
}
$txtNomActividad=(isset($_POST['txtNomActividad']))?$_POST['txtNomActividad']:"";

$action=(isset($_POST['action']))?$_POST['action']:"";

switch($action){
    case "Agregar":
        if($txtNomActividad == ""){
            $error = $error."-Debe ingresar un nombre<br>";
        }
        $txtNomActividad = limpiaHTML($txtNomActividad);
        
        try{
            $sql=$conexion->prepare("SELECT * FROM actividades where detalle LIKE :detalle;");  
            $sql->bindParam(":detalle",$txtNomActividad);
            $sql->execute();
            if($sql->rowCount() > 0){
                $error = $error."-El nombre ingresado ya se encuentra en nuestros registros<br>";
            }
        }catch (Exception $err) {
            echo ("Ha ocurrido un error en la solicitud. ");  
        }
        if(strlen($error) == 0){
            try{
                $sql=$conexion->prepare("INSERT INTO actividades (activo,detalle) 
                VALUES (:activo,:detalle);"); 
                $sql->bindParam(":activo",$chkActivo);
                $sql->bindParam(":detalle",$txtNomActividad);
                $sql->execute();
                echo("<script>alert('Se ha ingresado el registro satisfactoriamente');</script>");
                echo "<script>location.href='$html';</script>";
            }catch (Exception $err) {
                $error = ("Ha ocurrido un error al agregar la solicitud");    
                //throw $th;
            }
        }
        break;
    case "Modificar":
            if($txtNomActividad == ""){
                $error = $error."-Debe ingresar un nombre<br>";
            }
            $txtNomActividad = limpiaHTML($txtNomActividad);
            if(strlen($error) == 0){
                try{
                    $sql=$conexion->prepare("UPDATE actividades SET activo=:activo, detalle=:detalle where id=:id;");  
                    $sql->bindParam(":id",$txtId);
                    $sql->bindParam(":activo",$chkActivo);
                    $sql->bindParam(":detalle",$txtNomActividad);
                    $sql->execute();
                    echo("<script>alert('Se ha modificado el registro satisfactoriamente');</script>");
                    echo "<script>location.href='$html';</script>";
                }catch (Exception $err) {
                    $error = ("Ha ocurrido un error al modificar la solicitud");    
                    //throw $th;
                }
            }
        break;
    case "Volver":
        //header("location:index.php");
        echo "<script>location.href='index.php';</script>";
        break;
    case "Seleccionar":
        try{
            $sql=$conexion->prepare("SELECT * FROM actividades where id=:id;");  
            $sql->bindParam(":id",$txtId);
            $sql->execute();
            $Actividad = $sql->fetch(PDO::FETCH_LAZY); //1 solo atributo, para trabajar con él
            $txtId= $Actividad['id'];
            $chkActivo = $Actividad['activo']; //0 - inactivo / 1 - activo
            $txtNomActividad= $Actividad['detalle'];
        }catch (Exception $err) {
            $error = ("Ha ocurrido un error al seleccionar el registro");    
            //throw $th;
        }
        break;
}

$sqlActividades="SELECT id, detalle FROM actividades ";  
if($txtFiltro!="" ){
    $sqlActividades = $sqlActividades . " where detalle LIKE :id ";
}
try{
    $sql=$conexion->prepare($sqlActividades); 
    if($txtFiltro!="" ){
        $txtFiltro2=limpiaHTML("%".$txtFiltro."%");
        $sql->bindParam(":id",$txtFiltro2);
    }

    $sql->execute();
    if($sql->rowCount() > 0){
        $totalDatos = $sql->rowCount();
        $paginas = $totalDatos/$totalPaginas;
        $paginas = ceil($paginas);
    }else{
        $paginas = 1;
    }

}catch (Exception $err) {
    echo ("Ha ocurrido un error en la solicitud. "); 
}

if(is_null($_GET['pagina'])){
    $getPagina=0;
}else{
    $getPagina = intval($_GET['pagina']);
}

$iniciar = ($getPagina-1) * $totalPaginas;
$sqlActividades=$sqlActividades." ORDER BY id desc LIMIT :iniciar,:totalPaginas;";

try{
    $sql=$conexion->prepare($sqlActividades); 
    if($txtFiltro!="" ){
        $txtFiltro2=limpiaHTML("%".$txtFiltro."%");
        $sql->bindParam(":id",$txtFiltro2);
    }
    $sql->bindParam(":iniciar",$iniciar, PDO::PARAM_INT);
    $sql->bindParam(":totalPaginas",$totalPaginas, PDO::PARAM_INT);
    $sql->execute();
}catch (Exception $err) {
    echo ("Ha ocurrido un error en la solicitud. ");    
    throw $err;
}
$listaActividades = $sql->fetchAll(PDO::FETCH_ASSOC); //almacena todos los registros como arreglo
?>
<div class="col-md-4">
    <div class="card">
        <div class="card-header">
            <h4>Actividad<h4/>
        </div>
        <div class="card-body">
                <?php if(strlen($error) > 0) {?>
                    <div class='alert alert-danger' role="alert">
                        <?php echo $error; ?>
                    </div>
                <?php }?>
            <form method="POST" enctype="multipart/form-data">
                <input type="hidden" class="form-control" name="txtId" id="txtId" value="<?php echo $txtId; ?>" >
                <div class="form-check form-switch">
                    <label for="chkActivo">Activo</label>
                    <input class="form-check-input" type="checkbox" id="chkActivo" name="chkActivo" <?php if($chkActivo == "1") {echo ("checked"); } ?>>
                </div>
                <div class = "form-group">
                    <label for="exampleSelect1" class="form-label mt-1">Nombre actividad*</label>
                    <input type="text" required class="form-control" name="txtNomActividad" id="txtNomActividad" value="<?php echo $txtNomActividad; ?>">
                </div>
                
                
                <br/>
                <div class="btn-group" role="group" aria-label="">
                    <button type="submit" name="action" <?php if ($action=="Seleccionar" or $action=="Modificar"  ){echo ("disabled");} ?> value="Agregar" class="btn btn-outline-success" onclick="return confirm('¿Está seguro de agregar el registro?')">Agregar</button> &nbsp;
                    <button type="submit" name="action" <?php if ($action!="Seleccionar" and $action!="Modificar"){echo ("disabled");} ?> value="Modificar" class="btn btn-outline-warning" onclick="return confirm('¿Está seguro de modificar el registro?')">Modificar</button>&nbsp;
                    <button type="submit" name="action" formnovalidate="" value="Volver" class="btn btn-outline-info">Volver</button>
                </div>
            </form>
        </div>
    </div>
</div>
<div class="col-md-8">
        <form class="d-flex" method="GET">
            <input type="hidden" class="form-control" name="pagina" id="pagina" value="<?php echo $getPagina; ?>" >
            <input class="form-control me-sm-2" type="text" placeholder="filtrar" name="txtFiltro" id="txtFiltro" value="<?php echo ($txtFiltro!="")?$txtFiltro:""; ?>">
            <button class="btn btn-outline-info" name="action" type="submit" value="Filtrar">Filtrar</button>
        </form>
    <table class="table table-hover">
        <thead>
            <tr>
                <th>ID</th>
                <th>nombre</th>
                <th>Acci&oacute;n</th>
            </tr>
        </thead>
        <tbody>
            <?php 
            foreach($listaActividades as $act) { ?>
            <tr>
                <td><?php echo $act['id'] ?></td>
                <td><?php echo $act['detalle'] ?></td>
                <td>
                    <form method="post">
                        <input type="hidden" name="txtId" id="txtId" value="<?php echo $act['id'] ?>">
                        <button type="submit" name="action" class="btn btn-outline-dark" value="Seleccionar">
                            <i type="submit" class="bi bi-check2-circle" style="font-size: 1rem; color: #BA0700;"></i>
                        </button>
                    </form>
                </td>
            </tr>
            <?php } ?>
        </tbody>
    </table>
    <div>
        <ul class="pagination">
            <li class="page-item <?php echo ($getPagina<=1)?"disabled":""; ?>">
                <a class="page-link" href="<?php echo $html; ?>?pagina=<?php echo $getPagina-1 ?>&txtFiltro=<?php echo $txtFiltro; ?>">&laquo;</a>
            </li>
            <?php for($i=0; $i< $paginas; $i++ ) { 
                    if((($i+1)%$paginadorSalto)==0){
                        echo("</ul><ul class='pagination'>");
                    } 
                ?>
            <li class="page-item <?php echo ($getPagina==$i+1)?"active":""; ?>">
                <a class="page-link" href="<?php echo $html; ?>?pagina=<?php echo $i+1 ?>&txtFiltro=<?php echo $txtFiltro; ?>"><?php echo $i+1 ?></a>
            </li>
            <?php } ?>
            <li class="page-item <?php echo ($getPagina>=$paginas)?"disabled":""; ?>">
                <a class="page-link" href="<?php echo $html; ?>?pagina=<?php echo $getPagina+1 ?>&txtFiltro=<?php echo $txtFiltro; ?>">&raquo;</a>
            </li>
        </ul>
    </div>
</div>

<?php include('./templates/pie.php'); ?>